; simple helper alias i wrote up really quick to pick the lower of the 2 enabled fields (global and network)
alias -l lowest {
  if (($1 !isnum) || ($2 !isnum)) return
  if ($1 > $2) return $2
  if ($2 > $1) return $1
  return $1
}


;Usage:

; $autoperf(network).enabled returns enabled state of 'network'
; $autoperf().enabled returns enabled state of global

; autoperf set [global/network] [function] [data] where 'global' means global, network  
; name means network name, function means which setting to modify, and data is the data
; to set that setting to.

; autoperf global [event] initiates execution of global commands for a given event
; autoperf [event] initiates execution of network commands for a given event

; autoperf behavior [network] [0,1,2] modifies 'enabled' setting for global or network if network is specified
; autoperf default [0,1,2] modifies the default 'enabled' setting.
; autoperf activates help interface
; autoperf help activates help interface

alias autoperf {
  if ($isid) {
    ; used to get privledges

    if ($prop == enabled) {
      ; if a network is specified
      if ($1) {
        return $iif($readini($scriptdir\autoperform.ini,net. $+ $1 $+ ,enabled) != $null,$v1,$readini($scriptdir\autoperform.ini,global,default))
      }
      ; if a network isn't specified, assume request is for global
      else {
        return $readini($scriptdir\autoperform.ini,global,enabled)
      }
    }
  }

  ; autoperf set [global/network] [function] [data] where 'global' means global, network  
  ; name means network name, function means which setting to modify, and data is the data
  ; to set that setting to.

  else {
    if ($1 == set) {
      writeini -n $scriptdir\autoperform.ini $iif($2 == global,global,net. $+ $2 $+ ) $3-
      return
    }

    ; autoperf activates help interface
    ; autoperf help activates help interface

    if ((!$1) || ($1 == help)) {
      .play -cs $scriptdir\autoperf.info 0
      return
    }

    ; autoperf behavior [network] [0,1,2] modifies 'enabled' setting for global or network if network is specified
    ; autoperf default [0,1,2] modifies the default 'enabled' setting.
    if ($1 == behavior) {
      if ($3 != $null) {
        writeini -n $scriptdir\autoperform.ini net. $+ $2 enabled $3
        echo -a Behavior for $2 set to $3         
        return
      }
      elseif (($2 !isnum) && ($2)) {
        echo -a Behavior for $2 currently set to $iif($readini($scriptdir\autoperform.ini,net. $+ $2 $+,enabled) != $null,$v1,$readini($scriptdir\autoperform.ini,global,default))
        return
      }
      elseif ($2 == $null) {
        echo -a Global behavior currently set to $readini($scriptdir\autoperform.ini,global,enabled))
        return
      }
      else {
        echo -a Global behavior set to $2
        writeini -n $scriptdir\autoperform.ini global enabled $2
        return
      }
    }
    if ($1 == default) {
      if ($2 == $null) {
        echo -a Current behavior set to: $readini($scriptdir\autoperform.ini,global,default)
        return
      }
      writeini -n $scriptdir\autoperform.ini global default $2
      echo -a Default behavior set to $2
      return
    }

    ; autoperf global [event] initiates execution of global commands for a given event
    ; autoperf [event] initiates execution of network commands for a given event
    if ($1 == global) {
      var %global = $true
      tokenize 32 $2-
    }
    var %file = $scriptdir\ $+ $iif(%global, $+ $1 $+ .global.perf, $+ $network $+ . $+ $1 $+ .perf)
    if ($exists(%file)) {
      .play -cs %file 0
      return
    }
  }
}


on *:start: {
  if ($autoperf().enabled >= 2) {
    autoperf global startup
  }
}

on *:connect: {
  if ($lowest($autoperf().enabled,$autoperf($network).enabled) >= 2) {
    autoperf global connect
  }
  if ($lowest($autoperf().enabled,$autoperf($network).enabled) >= 1) {
    autoperf connect
  }
  else return
}

on *:notice:*identified*:*: {
  if ($nick == NickServ) {
    echo 4 -s Identified to Nickserv
    if ($lowest($autoperf($network).enabled),$autoperf().enabled) >= 2) {
      autoperf global loggedin
    }
    if ($lowest($autoperf($network).enabled),$autoperf().enabled) >= 1) {
      autoperf loggedin
    }
  }
}
raw 901:*: {
  if ($lowest($autoperf($network).enabled),$autoperf().enabled) >= 2) {
    autoperf global loggedin
  }
  if ($lowest($autoperf($network).enabled),$autoperf().enabled) >= 1) {
    autoperf loggedin
  }
}
